--- a/arch/mips/bcm63xx/boards/board_bcm963xx.c
+++ b/arch/mips/bcm63xx/boards/board_bcm963xx.c
@@ -1365,6 +1365,37 @@ static struct board_info __initdata boar
 	},
 };
 
+static struct board_info __initdata board_HW520 = {
+	.name				= "HW6358GW_B",
+	.expected_cpu_id		= 0x6358,
+
+	.has_uart0			= 1,
+	.has_pci			= 1,
+	.use_fallback_sprom		= 1,
+	.has_ohci0			= 1,
+	.has_ehci0			= 1,
+
+	.has_enet0			= 1,
+	.enet0 = {
+		.has_phy		= 1,
+		.use_internal_phy	= 1,
+	},
+
+	.has_enet1			= 1,
+	.enet1 = {
+		.has_phy		= 1,
+		.phy_id			= 0,
+		.force_speed_100	= 1,
+		.force_duplex_full	= 1,
+	},
+
+	.fallback_sprom = {
+		.type 				= SPROM_BCM4318,
+		.pci_bus			= 0,
+		.pci_dev			= 1,
+	},
+};
+
 static struct board_info __initdata board_HW553 = {
 	.name                           = "HW553",
 	.expected_cpu_id                = 0x6358,
@@ -2147,6 +2178,7 @@ static const struct board_info __initcon
 	&board_nb4_ser_r0,
 	&board_nb4_fxc_r1,
 	&board_ct6373_1,
+	&board_HW520,
 	&board_HW553,
 	&board_HW556_A,
 	&board_HW556_B,
@@ -2239,6 +2271,7 @@ static struct of_device_id const bcm963x
 	{ .compatible = "d-link,dsl-274xb-c2", .data = &board_dsl_274xb_rev_c, },
 	{ .compatible = "d-link,dsl-2650u", .data = &board_96358vw2, },
 	{ .compatible = "d-link,dva-g3810bn/tl", .data = &board_DVAG3810BN, },
+	{ .compatible = "huawei,hg520v", .data = &board_HW520, },
 	{ .compatible = "huawei,hg553", .data = &board_HW553, },
 	{ .compatible = "huawei,hg556a-a", .data = &board_HW556_A, },
 	{ .compatible = "huawei,hg556a-b", .data = &board_HW556_B, },
